﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Input;

namespace CommandAndEnum
{
    class DelegateCommand<T> : ICommand
    {
        Action<T> _action;

        public DelegateCommand(Action<T> action)
        {
            _action = action;
        }

        public bool CanExecute(object parameter)
        {
            return true;
        }

        public event EventHandler CanExecuteChanged;

        public void Execute(object parameter)
        {
            _action((T)parameter);
        }

    }

    class DelegateCommand : DelegateCommand<object>
    {
        Action _action;

        public DelegateCommand(Action action)
            :
            base( ignored=>action() )
        {
        }
    }

}
